<?php

/**
 * The plugin bootstrap file
 *
 * This file is read by WordPress to generate the plugin information in the plugin
 * admin area. This file also includes all of the dependencies used by the plugin,
 * registers the activation and deactivation functions, and defines a function
 * that starts the plugin.
 *
 * @link              https://rescuethemes.com
 * @since             1.0.0
 * @package           Nutritionwp
 *
 * @wordpress-plugin
 * Plugin Name:       NutritionWP
 * Plugin URI:        https://rescuethemes.com/wordpress-plugins/nutritionwp/
 * Description:       Super easy free recipe plugin with nutritional facts. Made by a foodie!
 * Version:           1.1
 * Author:            rescuethemes.com
 * Author URI:        https://rescuethemes.com
 * License:           GPL-2.0+
 * License URI:       http://www.gnu.org/licenses/gpl-2.0.txt
 * Text Domain:       nutritionwp
 * Domain Path:       /languages
 */

// If this file is called directly, abort.
if ( ! defined( 'WPINC' ) ) {
	die;
}

/**
 * The code that runs during plugin activation.
 * This action is documented in includes/class-nutritionwp-activator.php
 */
function activate_nutritionwp() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-nutritionwp-activator.php';
	Nutritionwp_Activator::activate();
}

/**
 * The code that runs during plugin deactivation.
 * This action is documented in includes/class-nutritionwp-deactivator.php
 */
function deactivate_nutritionwp() {
	require_once plugin_dir_path( __FILE__ ) . 'includes/class-nutritionwp-deactivator.php';
	Nutritionwp_Deactivator::deactivate();
}

register_activation_hook( __FILE__, 'activate_nutritionwp' );
register_deactivation_hook( __FILE__, 'deactivate_nutritionwp' );

/**
 * The core plugin class that is used to define internationalization,
 * admin-specific hooks, and public-facing site hooks.
 */
require plugin_dir_path( __FILE__ ) . 'includes/class-nutritionwp.php';

/**
 * Begins execution of the plugin.
 *
 * Since everything within the plugin is registered via hooks,
 * then kicking off the plugin from this point in the file does
 * not affect the page life cycle.
 *
 * @since    1.0.0
 */
function run_nutritionwp() {

	$plugin = new Nutritionwp();
	$plugin->run();

}
run_nutritionwp();
