<?php 
/**
 * Template tags for directions.
 *
 * @since 1.0.0
 *
 */


function nwp_get_directions( $args = array() ) {

	$directions = $recipe->get_directions( $args );

	/**
	 * Filter array of directions.
	 *
	 * @since 1.0.0
	 *
	 * @param array $directions
	 */
	$directions = apply_filters( 'nwp_get_directions', $directions );

	return $directions;
}
	


/**
 * Get the Directions Heading.
 * 
 * @return string $directions_name
 */
function nwp_get_directions_heading() {

	$directions_name = get_option( 'nwp_settings' )['directions_name'];
	
	if ( !$directions_name ) {
		
		$directions_name = __( 'Directions', 'nutritionWP' );
		
	} 
	/**
	 * Filter the Directions heading.
	 *
	 * @since 1.0.0
	 *
	 * @param string $directions_name
	 */
	$directions_name = apply_filters( 'nwp_directions_header_name', $directions_name );

	return $directions_name;
}
	
/**
 * Get the directions list style.
 *
 * @since 1.0.0
 *
 * @return string $style
 */
function nwp_get_directions_list_style() {

	$style = get_option( 'nwp_settings' )['directions_list_style'];

	if ( !$style ) {
		$style = 'ol';
	}
	
	return $style;

}	
	